"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Balloon = /** @class */ (function (_super) {
    __extends(Balloon, _super);
    function Balloon() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(Balloon.prototype, "balloonProps", {
        get: function () {
            return {
                className: this.props.balloonClassName,
                style: this.generateBalloonStyle()
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Balloon.prototype, "balloonArrowProps", {
        get: function () {
            return {
                className: this.props.balloonArrowClassName,
                style: this.generateBalloonArrowStyle()
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Balloon.prototype, "isLeftRight", {
        get: function () {
            return ['left', 'right'].includes(this.props.balloonArrowPosition);
        },
        enumerable: true,
        configurable: true
    });
    Balloon.prototype.generateBalloonStyle = function () {
        return __assign({ padding: '5px' }, this.props.balloonStyle, { position: "relative", color: this.props.balloonColor, backgroundColor: this.props.balloonBackgroundColor, border: "1px solid " + this.props.balloonBorderColor });
    };
    Balloon.prototype.generateBalloonArrowStyle = function () {
        var _a;
        var fixedPosAxis = this.props.balloonArrowPosition;
        var relativePosAxis = fixedPosAxis === "top" || fixedPosAxis === "bottom" ? "left" : "top";
        var arrowSize = this.generateBalloonArrowSize();
        return __assign({ zIndex: 10 }, this.props.balloonArrowStyle, (_a = { width: arrowSize.width.toFixed(0) + "px", height: arrowSize.height.toFixed(0) + "px", position: "absolute" }, _a[fixedPosAxis] = "100%", _a[relativePosAxis] = this.calculateBalloonArrowPositionOffset(), _a));
    };
    Balloon.prototype.generateBalloonArrowSize = function () {
        return {
            width: this.isLeftRight ? this.props.balloonArrowHeight : this.props.balloonArrowWidth,
            height: this.isLeftRight ? this.props.balloonArrowWidth : this.props.balloonArrowHeight,
        };
    };
    Balloon.prototype.generateBalloonArrowPoints = function () {
        var w = this.props.balloonArrowWidth;
        var h = this.props.balloonArrowHeight;
        var w2 = w / 2;
        switch (this.props.balloonArrowPosition) {
            case 'top': return "0,0 " + w2 + "," + h + " " + w + ",0";
            case 'right': return h + "," + w + " 0," + w2 + " " + h + ",0";
            case 'bottom': return "0," + h + " " + w2 + ",0 " + w + "," + h;
            case 'left': return "0," + w + " " + h + "," + w2 + " 0,0";
        }
    };
    Balloon.prototype.calculateBalloonArrowPositionOffset = function () {
        var _a = this.generateBalloonArrowSize(), width = _a.width, height = _a.height;
        var offset = this.props.balloonArrowPositionOffset;
        return this.isLeftRight
            ? "calc(" + offset + " - " + height / 2 + "px)"
            : "calc(" + offset + " - " + width / 2 + "px)";
    };
    Balloon.prototype.render = function () {
        var arrowPoints = this.generateBalloonArrowPoints();
        var arrowSize = this.generateBalloonArrowSize();
        if (!this.props.message) {
            return this.props.emptyMessage;
        }
        return (React.createElement("div", __assign({}, this.balloonProps),
            React.createElement("span", __assign({}, this.balloonArrowProps),
                React.createElement("svg", __assign({}, arrowSize, { xmlns: "http://www.w3.org/2000/svg", style: { verticalAlign: 'top' } }),
                    React.createElement("polygon", { points: arrowPoints, fill: this.props.balloonBackgroundColor }),
                    React.createElement("polyline", { points: arrowPoints, fill: "transparent", stroke: this.props.balloonBorderColor }))),
            this.props.message));
    };
    Balloon.defaultProps = {
        emptyMessage: null,
        balloonColor: 'white',
        balloonBackgroundColor: 'black',
        balloonBorderColor: 'black',
        balloonClassName: 'rc-balloon',
        balloonStyle: {},
        balloonArrowClassName: 'rc-balloon-arrow',
        balloonArrowStyle: {},
        balloonArrowWidth: 20,
        balloonArrowHeight: 10,
        balloonArrowPosition: 'top',
        balloonArrowPositionOffset: "50%"
    };
    return Balloon;
}(React.Component));
exports.default = Balloon;
